import Component from '@glimmer/component';
import type { Placement, Options as PopperOptions, Boundary, Padding, ModifierArguments, State } from '@popperjs/core';
export interface ContextualHelpElementSignature {
    Args: {
        autoPlacement?: boolean;
        placement?: Placement;
        viewportElement?: Boundary;
        viewportPadding?: Padding;
    };
}
/**
 Internal (abstract) component for contextual help markup. Should not be used directly.

 @class ContextualHelpElement
 @namespace Components
 @extends Glimmer.Component
 @private
 */
export default class ContextualHelpElement<Signature extends ContextualHelpElementSignature> extends Component<Signature> {
    /**
     * @property placement
     * @type string
     * @default 'top'
     * @public
     */
    placement: Placement;
    actualPlacement?: Placement;
    /**
     * @property fade
     * @type boolean
     * @default true
     * @public
     */
    fade: boolean;
    /**
     * @property showHelp
     * @type boolean
     * @default false
     * @public
     */
    showHelp: boolean;
    /**
     * If true component will render in place, rather than be wormholed.
     *
     * @property renderInPlace
     * @type boolean
     * @default true
     * @public
     */
    /**
     * Which element to align to
     *
     * @property popperTarget
     * @type {string|HTMLElement}
     * @public
     */
    /**
     * @property autoPlacement
     * @type boolean
     * @default true
     * @public
     */
    /**
     * The DOM element of the viewport element.
     *
     * @property viewportElement
     * @type object
     * @public
     */
    /**
     * Take a padding into account for keeping the tooltip/popover within the bounds of the element given by `viewportElement`.
     *
     * @property viewportPadding
     * @type number
     * @default 0
     * @public
     */
    /**
     * @property arrowClass
     * @private
     */
    arrowClass: string;
    placementClassPrefix: string;
    offset: number[];
    popperElement: HTMLElement;
    /**
     * popper.js modifier config
     *
     * @property popperModifiers
     * @type {object}
     * @private
     */
    get popperOptions(): PopperOptions;
    get actualPlacementClass(): string;
    updatePlacement(state: Partial<State> | ModifierArguments<object>): void;
}
//# sourceMappingURL=element.d.ts.map